#!/usr/bin/perl -W
#-------------------------------Licence GNU/GPL---------------------------------------
#Copyright GtkSysinfo Pissens Sbastien
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#--------------------------------------------------------------------------------------


#--------------------#
use Gtk2 '-init';
use Gtk2::SimpleList;
use Gtk2::TrayIcon;
use GtkSysinfo::Functions;
use strict;
#--------------------#

#----------Ajuster en fonction de lm_sensors-------#
#Les Noms des sensors peuvent changer en fonction de votre carte mere :(
#il faut donc parfois modifier les valeurs de ces deux variables en fouction
#du rsultat de la commande sensors
my $CPUSensors = "Temp3:";
my $BoitierSensors = "M/B";
my $lang = "hu";
#--------------------------------------------------#
my $file = "$0";
$file =~ s/Sysinfo.pl//gi;

my $millisec = 10000;
my $Version = "1.9";
my $tray = 1;
my $launch = 1;
my $ACPI;
my $acpi = 0;
my $refresh = 1;
while (my $option = shift) {
	if ($option eq "--notray") {
		$tray = 0;
	} elsif ($option =~ /.*--millisec.*/) {
		(my $brol,$millisec) = split("=",$option);		
	} elsif ($option eq "--help") {
		print "Sysinfo $Version by Pissens Sbastien\n\n";
		print "Options :\n\n";
		print "          --notray                                Desactive the System Tray Icon\n";
		print "          --millisec=<nb>                         Modify the refresh time(Default = 1000)\n";
		print "          --norefresh                             Desactive the refresh timer\n";
		print "          --cpu=<sensorname>                      Modify the name of the CPU sensor\n";
		print "          --tower=<sensorname>                    Modify the name of the Tower sensor\n";
		print "          --acpi                                  Active the ACPI support\n";
		print "          --lang=<language>                       Change the language (default=en)\n\n";
		$launch = 0;
	} elsif ($option =~ /.*--cpu.*/) {
		(my $brol,$CPUSensors) = split("=",$option);
	} elsif ($option =~ /.*--tower.*/) {
		(my $brol,$BoitierSensors) = split("=",$option);
	} elsif ($option eq "--acpi") {
		$ACPI = "/proc/acpi/";
		if (-e $ACPI) {
			$acpi = 1;	
		} else {
			print "Acpi Not Found...\n";
			$launch = 0;
		}	
	} elsif ($option =~ /.*--lang.*/) {
		(my $brol,$lang) = split("=",$option);
	} elsif ($option =~ /.*--norefresh.*/) {
		$refresh = 0;
	} elsif ($option ne "") {
		print "Type --help for more information about options\n";
		$launch = 0;
	}
}

if ($launch == 1) {
my @LANG;
my $langfile = $file."lang/lang.".$lang;
if (! -e $langfile) {
	print "Language not found, Default = French\n";
	$langfile = $file."lang/lang.fr";
}


print "charging language , please wait ...\n";
open(FICHIER, $langfile);
my $comp = 0;
my $ligne;
while ($ligne = <FICHIER>) {
	$LANG[$comp] = $ligne;
	chomp($LANG[$comp]);
	$comp += 1;
}
close(FICHIER);
#-----------Init-----------------#
#Dfinition des variables souvent utilises pour une meilleure lisibilit du code
my $window;
my $notebook;
my $false = 0;
my $true = 1;
my $traymsg = $LANG[94];
my $frame;
my $table;
my $label;
my $nv = $true;
my $sens = $true;
my $kdev = $true;
my $alsactl = $true;
my $acpitemp1 = $false;
#--------------------------------#

#-------------------------------------------------------#
# Rcupration des chemins des commandes grce a which
#-------------------------------------------------------#
my $CAT = `which cat 2>&1`;
chomp($CAT);
my $GREP = `which grep 2>&1`;
chomp($GREP);
my $HOST = `which hostname 2>&1`;
chomp($HOST);
my $IFCONFIG = `which ifconfig 2>&1`;
chomp($IFCONFIG);
my $WHO = `which who 2>&1`;
chomp($WHO);
my $LSPCI = `which lspci 2>&1`;
chomp ($LSPCI);
my $DF = `which df 2>&1`;
chomp($DF);
my $NVIDIA = `which nvidia-settings 2>&1`;
chomp($NVIDIA);
my $SENSORS = `which sensors 2>&1`;
chomp($SENSORS);
my $LOGPATH = $file."sysinfo.log";
my $KDE = `which kde-config 2>&1`;
chomp($KDE);
my $SED = `which sed 2>&1`;
chomp($SED);
my $X = `which xdpyinfo 2>&1`;
chomp($X);
my $UPTIME = `which uptime 2>&1`;
chomp($UPTIME);
my $AWK = `which awk 2>&1`;
chomp($AWK); 
my $GCC = `which gcc 2>&1`;
chomp($GCC);
my $PERL = `which perl 2>&1`;
chomp($PERL);
my $PYTHON = `which python 2>&1`;
chomp($PYTHON);
my $ALSA = `which alsactl 2>&1`;
chomp($ALSA);
my $HEAD = `which head 2>&1`;
chomp($HEAD);
my $GNOME = "/usr/share/gnome-about/gnome-version.xml";
my $ICEWM = `which icewm 2>&1`;
chomp($ICEWM);
my $FLUXBOX = `which fluxbox 2>&1`;
chomp($FLUXBOX);
my $ROUTE = `which route 2>&1`;
chomp($ROUTE);
my $GLIB = `which glib-config 2>&1`;
chomp($GLIB);
my $AUMIX = `which aumix 2>&1`;
chomp($AUMIX);
#my $PING = `which ping 2>&1`;
#chomp($PING);
#------------------Teste des commandes-------------------------------------#
#On teste ici les diffrentes commandes , selon l'importance de la commande
#l'application se lancera ($result = 1) et affichera un message d'erreur a l'ecran et des explications
#dans le fichier sysinfo.log ou l'application ne se lancera pas ($result = 0) 
#Si vous changez la valeur d'un $result pour faire fonctionner l'application, vous
#risquez d'avoir quelques problemes :p 
sub Commande {
my $result = 1;
print ($LANG[3]." sed...");
if (! -e $SED) {
	print ($LANG[7]."\n".$LANG[4]." sed ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n"); }
print ($LANG[3]." cat...");
 if (! -e $CAT) {
	print ($LANG[7]."\n".$LANG[4]." cat ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n");
 print ($LANG[3]." grep...");}
 if (! -e $GREP) {
	print ($LANG[7]."\n".$LANG[4]." grep ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n");}
 print ($LANG[3]." hostname...");
 if (! -e $HOST) {
	print ($LANG[7]."\n".$LANG[4]." hostname ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n");}
print ($LANG[3]." awk...");
if (! -e $AWK) {
	print ($LANG[7]."\n".$LANG[4]." awk ".$LANG[5]."\n");
	$result = 0;
} else { print ($LANG[6]."\n");}
 print ($LANG[3]." uptime...");
 if (! -e $UPTIME) {
	print ($LANG[7]."\n".$LANG[4]." uptime ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n");}
 print ($LANG[3]." xdpyinfo...");
 if (! -e $X) {
	print ($LANG[7]."\n".$LANG[4]." xdpyinfo ".$LANG[5]."\n");
	$result = 0;
 } else { print ($LANG[6]."\n");}
 print ($LANG[3]." gcc...");
 if (! -e $GCC) {
	print ($LANG[7]."\n".$LANG[4]." gcc ".$LANG[5]."\n");
	$result = 1;
	$GCC = "Not Found"; 
 } else { print ($LANG[6]."\n");}
  print ($LANG[3]." perl...");
 if (! -e $PERL) {
	print ($LANG[7]."\n".$LANG[4]." perl ".$LANG[5]."\n");
	$result = 1;
	$PERL = "Not Found"; 
 } else { print ($LANG[6]."\n");}
print ($LANG[3]." glib-config...");
if (! -e $GLIB) {
	print ($LANG[7]."\n".$LANG[4]." glib-config ".$LANG[5]."\n");
	$result = 1;
	$GLIB = "Not Found"; 
} else { print ($LANG[6]."\n");}
 print ($LANG[3]." python...");
 if (! -e $PYTHON) {
	print ($LANG[7]."\n".$LANG[4]." python ".$LANG[5]."\n");
	$result = 1;
	$PYTHON = "Not Found"; 
 } else { print ($LANG[6]."\n");}
print ($LANG[3]." head...");
 if (! -e $HEAD) {
	print ($LANG[7]."\n".$LANG[4]." head ".$LANG[5]."\n");
	$result = 1;
	$GNOME = "Not Found"; 
	logmsg($LANG[8]);
} else { print ($LANG[6]."\n");} 
print ($LANG[3]." ifconfig...");
if (! -e $IFCONFIG) {
        print ($LANG[7]."\n".$LANG[9]." ifconfig ".$LANG[10]." /sbin/");
	$IFCONFIG = "/sbin/ifconfig";
	if (! -e $IFCONFIG) {
	       print ("... ".$LANG[7]."\n");
               $result = 0;
	} else { print ("... ".$LANG[6]."\n"); }
        } else { print ($LANG[6]."\n");}

print ($LANG[3]." route...");
if (! -e $ROUTE) {
	print ($LANG[7]."\n".$LANG[9]." route ".$LANG[10]." /usr/sbin/...");
	$ROUTE = "/usr/sbin/route";
	if (! -e $ROUTE) {
		print ($LANG[7]."\n".$LANG[9]." route ".$LANG[10]." /sbin/");
		$ROUTE = "/sbin/route";
		if (! -e $ROUTE) {
        		print ("... ".$LANG[7]."\n");
			$result = 0;
		} else { print ("... ".$LANG[6]."\n"); }
	} else { print ("... ".$LANG[6]."\n"); }
        } else { print ($LANG[6]."\n");}	
	
print ($LANG[3]." lspci...");
if (! -e $LSPCI) {
	print ($LANG[7]."\n".$LANG[9]." lspci ".$LANG[10]." /usr/sbin/");
	$LSPCI = "/usr/sbin/lspci";
	if (! -e $LSPCI) {
		print ($LANG[7]."\n".$LANG[9]." lspci ".$LANG[10]." /sbin/");
		$LSPCI = "/sbin/lspci";
		if (! -e $LSPCI) {
        		print ("... ".$LANG[7]."\n");
			logmsg($LANG[11]."\n");
               		$result = 0;
		} else { print ("... ".$LANG[7]."\n"); }
	} else { print ("... ".$LANG[7]."\n"); }
        } else { print ($LANG[6]."\n");}
	
print ($LANG[3]." alsa...");
if (! -e $ALSA) {
	print ($LANG[7]."\n".$LANG[9]." alsa ".$LANG[10]." /usr/sbin/");
	$ALSA = "/usr/sbin/alsactl";
	if (! -e $ALSA) {
		print ($LANG[7]."\n".$LANG[9]." alsa ".$LANG[10]." /sbin/");
		$ALSA = "/sbin/alsactl";
		if (! -e $ALSA) {
        		print ("... ".$LANG[7]."\n");
			logmsg($LANG[3]." alsactl ".$LANG[7]." ...\n");
			$alsactl = $false;
               		$result = 1;
		} else { print ("... ".$LANG[6]."\n"); }
	} else { print ("... ".$LANG[6]."\n"); }
        } else { print ($LANG[6]."\n");}
	
print ("kde-config...");
if (! -e $KDE) {
	print ($LANG[7]."\n");
	logmsg($LANG[12]);
	$kdev = $false;
	} else { print ($LANG[6]."\n");}
print ($LANG[3]." nvidia-settings...");
if (! -e $NVIDIA) {
	print ($LANG[7]."\n");
        logmsg($LANG[13]."\n");
               $result = 1;
	       $nv = $false;
        } else { print ($LANG[6]."\n");}
print ($LANG[3]." sensors...");
if (! -e $SENSORS) {
	print ($LANG[7]."\n");
	logmsg($LANG [14]."\n");
	$result = 1;
	$sens = $false;

} else { print ($LANG[6]."\n");
	 my $test = `$SENSORS 2>&1 | tail -1`;
	 if ($test =~ /.*No sensors found.*/) {
	 	$sens = $false;
		print $LANG[15]." ".$LANG[94]."\n";
	 } elsif ($test =~ /.*kernels.*/) {
	 	print $LANG[16]."\n";
		$sens = $false;
	 }
	 
        }      

 return $result;
}

InitFunctions(); #init Functions.pm 

print "#----------------------------".$LANG[108]."--------------------------#\n";
if (Commande() == $false) { #Le programme ne se lancera pas si Commande() renvoit false (0)
	
	logmsg($LANG[17]."\n");
	print ($LANG[18]);
	
} else {
print "#--------------------------------------------------------------------#\n";

print $LANG[107];
#-------------------Fenetre Principal-------------------------------------------
$window = Gtk2::Window->new( "toplevel" ); 
$window->set_position("center"); #Position de la fenetre a la cration
$window->set_title("GtkSysInfo" ); #Titre de l'application
$window->set_icon_from_file($file."images/icon.png"); #Icone de la fenetre principale
$window->realize();
$window->set_resizable($false); #La Taille de la fenetre ne pourra pas tre change
my $icontray;
my $tooltipstray;
if ($tray == 1) {
  $icontray = Gtk2::TrayIcon->new("GtkSysinfo");
  my $img = Gtk2::Image->new_from_file ($file."images/icontray.png");
  $tooltipstray = Gtk2::Tooltips->new(); 
  my $traybox =  Gtk2::EventBox->new();
  $traybox->add($img);
  $icontray->add($traybox);
  $icontray->show_all;
  $traybox->signal_connect(button_press_event => sub {
  							my ($widget, $event) = @_;    
    							if ($event->button() == 3) {
								my $menu = Gtk2::Menu->new();
								my $menuitem2  = Gtk2::ImageMenuItem->new_with_label($LANG[19]);
								$menuitem2->set_image(Gtk2::Image->new_from_stock("gtk-yes","menu"));  
								my $menuitem3 = Gtk2::ImageMenuItem->new_with_label($LANG[165]);
								$menuitem3->set_image(Gtk2::Image->new_from_stock("gtk-refresh","menu"));  
								my $menuitem1 = Gtk2::ImageMenuItem->new_with_label($LANG[20]);
								$menuitem1->set_image(Gtk2::Image->new_from_stock("gtk-quit","menu"));  
								$menuitem1->signal_connect(activate =>sub { Gtk2->main_quit; });
								$menuitem2->signal_connect(activate =>sub { $window->show_all; });
								$menuitem3->signal_connect('activate', \&Refresh );
								$menuitem1->show();
								$menuitem2->show();
								$menuitem3->show();
								$menu->append($menuitem2);
								$menu->append($menuitem3);
								$menu->append($menuitem1);									
								$menu->popup(undef,undef,undef,undef,$event->button,$event->time);
							} elsif ($event->button() == 1) {
								my $etat = $window->visible;
								if ($etat == $true) {
									$window->hide;
								} else {
									$window->show_all;
								}
							}
						       });
  $window->signal_connect( "delete_event", sub { $window->hide; return $true;} );  
} else {
  $window->signal_connect( "delete_event", \&CloseAppWindow );
}
  
#------------------Table-------------------------------------------------------
$table = new Gtk2::Table( 4, 6, $false ); #Cration d'une table de 4lignes et de 6 Colonnes
$window->add( $table ); #Ajout de la Table a la Fenetre principale

#---------------------------Menu-----------------------------------------------
my $box1 = new Gtk2::VBox( 0, 0 ); #Cration d'une Box a alignement Verticale
$box1->set_border_width( 0 ); #aucune Bordure a la Box
$box1->show();
my $Mymenu = new Gtk2::Menu(); #Creation du Menu 1
my $MyAide = new Gtk2::Menu(); #Creation du Menu 2
#my $MyOutils = new Gtk2::Menu();
my $menubar = new Gtk2::MenuBar(); #Creation de la bar de Menu
$box1->add( $menubar );  #Ajout de la barre de Menu dans notre Box a alignement Vertical
$menubar->show();
my $menu = new Gtk2::MenuItem( $LANG[109] ); #Creation de l'item de menu "Menu"
$menubar->append( $menu ); #Ajout du Menu item dans la barre de Menu
$menu->set_submenu( $Mymenu ); #Ajout du Menu 1 comme Sous Menu du Menu Item "Menu"
#my $Outils = new Gtk2::MenuItem( "Outils" );
#$menubar->append( $Outils );
#$Outils->set_submenu($MyOutils);
#my $menu_Ping = new Gtk2::MenuItem( "Ping" );
#$MyOutils->append( $menu_Ping ); 
my $Aide = new Gtk2::MenuItem( $LANG[21] ); #Creation de l'item de menu "Aide"
$menubar->append( $Aide ); #Ajout du Menu item dans la barre de Menu
$Aide->set_submenu( $MyAide ); #Ajout du Menu 2 comme Sous Menu du Menu Item "Aide"
my $licence = Gtk2::ImageMenuItem->new_with_label( $LANG[22] ); #Creation de l'item de menu "Licence"
$licence->set_image(Gtk2::Image->new_from_stock("gtk-help","menu")); 
$MyAide->append( $licence ); #Ajout du Item de Menu "Licence" comme Sous Menu du Menu 2
my $menu_APP = Gtk2::ImageMenuItem->new_with_label( $LANG[23] ); #Creation de l'item de menu "A Propos"
$menu_APP->set_image(Gtk2::Image->new_from_stock("gtk-dialog-question","menu"));  
$MyAide->append( $menu_APP ); #Ajout du Item de Menu "A Propos" comme Sous Menu du Menu 2
my $menu_itemR = Gtk2::ImageMenuItem->new_with_label($LANG[165]);  
$menu_itemR->set_image(Gtk2::Image->new_from_stock("gtk-refresh","menu"));  
$Mymenu->append( $menu_itemR ); 
my $menu_itemQ = Gtk2::ImageMenuItem->new_with_label($LANG[20]);  #Creation de l'item de menu "Quitter"
$menu_itemQ->set_image(Gtk2::Image->new_from_stock("gtk-quit","menu"));  
$Mymenu->append( $menu_itemQ ); #Ajout du Item de Menu "Quitter" comme Sous Menu du Menu 1
print("..");
#-------------------Actions-----------------------------
$menu_itemQ->signal_connect( 'activate', \&CloseAppWindow ); #Evenement de l'Item de menu "Quitter"
$menu_itemR->signal_connect( 'activate', \&Refresh );
$menu_APP->signal_connect( 'activate', \&About ); #Evenement de l'Item de menu "A Propos"
$licence->signal_connect( 'activate', \&Licence ); #Evenement de l'Item de menu "Licence"
#$menu_Ping->signal_connect( 'activate', sub {Outils("Ping")});
#-------------------------------------------------------
$table->attach_defaults( $box1, 0, 6, 0, 1 ); #Ajout du Menu tout en haut de la Table (Il prendra 6 colonnes et 1 ligne)
#------------------------------------------------------------------------------

#----------------------------Notebook------------------------------------------
$notebook = new Gtk2::Notebook(); #Cration d'un Notebook
$notebook->set_tab_pos( 'top' ); #Le notebook sera positionne en haut
$table->attach_defaults( $notebook, 0, 6, 1, 2 ); #Ajout du notebook a la table en dessous du Menu (Il prendra 6 colonnes et 1 ligne)
$notebook->show();

#-----------------------------CPU----------------------------------------------
   $frame = new Gtk2::Frame( $LANG[24] ); #Cration d'une Frame avec comme titre "Informations du Processeur" 
   $frame->set_size_request(800 ,500  ) ; #Dfinition de la Taille de la Frame
     
   $frame->show();
   my $vbox = new Gtk2::VBox( 0, 5 ); #Cration d'une Box a alignement Verticale
   
   my $frame1 = new Gtk2::Frame( $LANG[111] );
   $frame1->set_border_width(15);
   my $vbox2 = new Gtk2::VBox( 0, 5 ); 
   $label = new Gtk2::Label( $LANG[25]." ".Functions::cpu_info("vendor_id",$CAT,$GREP) ); #Creation d'un label 
   $vbox2->pack_start( $label,0, $true, 0 ); #Ajout du label dans notre Box a alignement Vertical 
   $label = new Gtk2::Label( $LANG[26]." ".Functions::cpu_info("name",$CAT,$GREP) );     # ect.... ;) 
   $vbox2->pack_start( $label,0, $true, 0 ); 	
   my $freq = 	Functions::cpu_info("MHz",$CAT,$GREP);    # Je ne vais pas expliquer 40 fois la meme chose 
   chomp($freq);
   $freq = round($freq);
   $label = new Gtk2::Label( $LANG[27]." ".$freq."Mhz\n" ); #Suis mazo mais pas a ce point :p 
   $vbox2->pack_start( $label,0, $true, 0 );
   $label = new Gtk2::Label( $LANG[28]." ".Functions::cpu_info("cache",$CAT,$GREP) );
   $vbox2->pack_start( $label,0, $true, 0 );
   $frame1->add( $vbox2);
   $vbox->pack_start( $frame1,0, $true, 0 );
      
   my $labelTCPU;
   my $labelTB;
   my $labelTV1;
   my $labelTV2;
   if ($sens == $true) {
        $frame1 = new Gtk2::Frame( $LANG[29] );
        $frame1->set_border_width(15);
	$vbox2 = new Gtk2::VBox( 0, 5 ); 
   	$labelTCPU = new Gtk2::Label($LANG[29]." : ".Functions::SensorsTemp($CPUSensors,$SENSORS,$GREP)."\n" );
	$vbox2->pack_start( $labelTCPU,0, $true, 0 );
	$labelTB = new Gtk2::Label($LANG[30]." ".Functions::SensorsTemp($BoitierSensors,$SENSORS,$GREP)."\n");
	$vbox2->pack_start( $labelTB,0, $true, 0 );
	$frame1->add( $vbox2);
   	$vbox->pack_start( $frame1,0, $true, 0 );
	if ($tray == 1) {
		$traymsg = "CPU : ".Functions::SensorsTemp($CPUSensors,$SENSORS,$GREP)."\n"."Tower : ".Functions::SensorsTemp($BoitierSensors,$SENSORS,$GREP);
	}
	$frame1 = new Gtk2::Frame( $LANG[31] );
        $frame1->set_border_width(15);
	$vbox2 = new Gtk2::VBox( 0, 5 ); 
	$labelTV1 = new Gtk2::Label($LANG[32]." 1 : ".Functions::SensorsTemp("fan1:",$SENSORS,$GREP)." RPM\n");
	$vbox2->pack_start( $labelTV1,0, $true, 0 );
	$labelTV2 = new Gtk2::Label($LANG[32]." 2 : ".Functions::SensorsTemp("fan2:",$SENSORS,$GREP)." RPM\n");
	$vbox2->pack_start( $labelTV2,0, $true, 0 );
	$frame1->add( $vbox2);
   	$vbox->pack_start( $frame1,0, $true, 0 );
   }
   $frame->add( $vbox ); #Ajout de la Box a alignement vertical dans la Frame
   $label = new Gtk2::Label( "CPU" ); #Creation du label qui servira de Titre dans notre Notebook 
   $notebook->append_page( $frame, $label ); #Acrochage de la Frame au Notebook abec comme Titre le Label defini au dessus


print("..");
#Ensuite c'est le mme principe pour toutes les partie du Notebook , on cree une frame , on cree
#une Box a alignement verticale, on ajoute nos lments dans la Box et on acrroche notre Frame au Notebook
#Pas compiqu GTK2 ;) (C'est moins lourd que l'API Windows :p)
#--------------------------Harware-----------------------------------------------
   $frame = new Gtk2::Frame();
   $frame->set_size_request(800 ,500) ; 
     
   $frame->show();
   
   my $hbox = new Gtk2::HBox( 0, 5 ); 
   my $sw = Gtk2::ScrolledWindow->new (undef, undef);
   $sw->set_size_request(400 ,600) ; 
   $sw->set_shadow_type ('etched-in');
   $sw->set_policy ('automatic', 'automatic');
   my $tree_model = Gtk2::TreeStore->new("Glib::String");
   my $tree = Gtk2::TreeView->new_with_model($tree_model);
   $tree->append_column(my $textcolumn = Gtk2::TreeViewColumn->new_with_attributes("  ".$LANG[33],Gtk2::CellRendererText->new,'text' => 0));
   my @hardware = (
                   [ "$LSPCI | $GREP \"Ethernet\\|Network\"", $LANG[128]." ".$LANG[129], "controller:" ],
 		   [ "$LSPCI | $GREP VGA", $LANG[128]." ".$LANG[130], "controller:" ],
                   [ "$LSPCI | $GREP Multimedia | $GREP audio", $LANG[128]." ".$LANG[131], "controller:" ],
		   [ "$LSPCI | $GREP Multimedia | $GREP video", $LANG[128]." ".$LANG[132], "controller:" ],
		   [ "$LSPCI | $GREP Modem", $LANG[128]." ".$LANG[133], "Modem:" ],
		   [ "$LSPCI | $GREP USB", $LANG[134]." ".$LANG[135], "Controller:" ],
		   [ "$LSPCI | $GREP IDE", $LANG[134]." ".$LANG[136], "interface:" ],
		   [ "$LSPCI | $GREP Bridge", $LANG[137], "bridge:" ]
                  );
   
   foreach (@hardware) {
   	$tree_model = Functions::addtree(${$_}[0],${$_}[1],${$_}[2],$tree_model);
   }
   
   $sw->add($tree);
   $hbox->pack_start( $sw,0, $true, 0 );
   $sw = Gtk2::ScrolledWindow->new (undef, undef);
   $sw->set_size_request(390,600) ; 
   $sw->set_shadow_type ('etched-in');
   $sw->set_policy ('automatic', 'automatic');
   my $text = Gtk2::TextView->new;
   $text->show;
   $text->set_editable($false);
   $text->set_cursor_visible($false);
   my $textbuffer = Gtk2::TextBuffer->new(undef);
   $textbuffer->insert_at_cursor("\n ".$LANG[34]);
   $text->set_buffer($textbuffer);
   $sw->add($text);
   $hbox->pack_start( $sw,0, $true, 0 );
   
   $tree->signal_connect (cursor_changed => sub {
   						  my $treeitem = $tree->get_selection;
						  my ($model, $iter) = $treeitem->get_selected;
						  my $item = $model->get_value ($iter);
						  my $textbuffer = Gtk2::TextBuffer->new(undef);
						  $textbuffer->insert_at_cursor(Functions::traiteCarte($item));
						  $text->set_buffer($textbuffer);
   						 } 
			 );
   
   $frame->add( $hbox );
   $label = new Gtk2::Label( $LANG[112] );
   $notebook->append_page( $frame, $label );
   
print("..");
#--------------------------Priphriques-----------------------------------------
   $frame = new Gtk2::Frame();
   $frame->set_size_request(800 ,500) ; 
     
   $frame->show();
   
   $hbox = new Gtk2::HBox( 0, 5 ); 
   $sw = Gtk2::ScrolledWindow->new (undef, undef);
   $sw->set_size_request(400 ,600) ; 
   $sw->set_shadow_type ('etched-in');
   $sw->set_policy ('automatic', 'automatic');
   my $tree_model2 = Gtk2::TreeStore->new("Glib::String");
   my $tree2 = Gtk2::TreeView->new_with_model($tree_model2);
   $tree2->append_column(my $textcolumn2 = Gtk2::TreeViewColumn->new_with_attributes("  ".$LANG[35],Gtk2::CellRendererText->new,'text' => 0));
    
   my @PeriUSB = Functions::PeriUSB($CAT,$GREP);
   my $iter = $tree_model2->append (undef);
   $tree_model2->set($iter, 0 ,$LANG[113]);
   my $cmpt = 1;
   foreach(@PeriUSB) {
   	if ($cmpt == 2) {
   		my $citer = $tree_model2->append ($iter);
		chomp($_);
   		$tree_model2->set($citer, 0 ,$_);
		$cmpt = 1;
	} else {
		$cmpt = 2;
	}
   }
   
   my @PeriInput = Functions::PeriInput($CAT,$GREP);
   $iter = $tree_model2->append (undef);
   $tree_model2->set($iter, 0 ,$LANG[36]);
   foreach(@PeriInput) {
   		my $citer = $tree_model2->append ($iter);
		chomp($_);
   		$tree_model2->set($citer, 0 ,$_);
   }
   
   my @DISC = Functions::PeriIDE($CAT);
   $iter = $tree_model2->append (undef);
   $tree_model2->set($iter, 0 ,$LANG[37]);
   foreach(@DISC) {
   		my $citer = $tree_model2->append ($iter);
		chomp(${$_}[0]);
   		$tree_model2->set($citer, 0 ,${$_}[0]);
   }
  
   $sw->add($tree2);
   $hbox->pack_start( $sw,0, $true, 0 );
   $sw = Gtk2::ScrolledWindow->new (undef, undef);
   $sw->set_size_request(390 ,600) ; 
   $sw->set_shadow_type ('etched-in');
   $sw->set_policy ('automatic', 'automatic');
   my $text2 = Gtk2::TextView->new;
   $text2->show;
   $text2->set_editable($false);
   $text2->set_cursor_visible($false);
   my $textbuffer2 = Gtk2::TextBuffer->new(undef);
   $textbuffer2->insert_at_cursor("\n ".$LANG[34]);
   $text2->set_buffer($textbuffer2);
   $sw->add($text2);
   $hbox->pack_start( $sw,0, $true, 0 );
   
   $tree2->signal_connect (cursor_changed => sub {
   						  my $treeitem = $tree2->get_selection;
						  my ($model, $iter) = $treeitem->get_selected;
						  my $item = $model->get_value($iter);
						  my $textbuffer = Gtk2::TextBuffer->new(undef);
						  my $cmp = 0;
						  my $result = "\n  ".$LANG[38];
						  foreach(@PeriUSB) {
						  if ($_ eq $item) {
							$result = Functions::InfoByProduct($cmp,@PeriUSB);
						  }
						  $cmp +=1;
						  }
						  foreach(@PeriInput) {
						  	if ($_ eq $item) {
								$result = "\n  ".$LANG[39]." ".$item; 
							}
						  }
						  foreach(@DISC) {
						  	if (${$_}[0] eq $item) {
								$result = Functions::DiscById($_);
							}
						  }						 
						  $textbuffer->insert_at_cursor($result);
						  $text2->set_buffer($textbuffer);
   						 } 
			 );
   
   $frame->add( $hbox );
   $label = new Gtk2::Label( $LANG[40] );
   $notebook->append_page( $frame, $label );




print("..");

#--------------------------Audio-------------------------------------------------
if ( -e $AUMIX) {   
   $frame = new Gtk2::Frame();
   $frame->set_size_request(800 ,500) ;     
   $frame->show();
 
   my @Audio = Functions::card("$LSPCI | $GREP Multimedia | $GREP audio", "controller:" );
   $vbox = new Gtk2::VBox( 0, 5 );
   
   $frame1 = new Gtk2::Frame( $LANG[168] );
   $frame1->set_border_width(15);
   $vbox2 = new Gtk2::VBox( 0, 5 ); 
   $label = new Gtk2::Label("\n".$Audio[0]."\n" ); 
   $vbox2->pack_start( $label,0, $true, 0 ); 
   $frame1->add( $vbox2 );   
   $vbox->pack_start( $frame1,0, $true, 0 );
   
   $frame1 = new Gtk2::Frame( $LANG[169] );
   $frame1->set_border_width(15);
   $vbox2 = new Gtk2::VBox( 0, 5 ); 
   $label = new Gtk2::Label("\n");
   $vbox2->pack_start( $label,0, $true, 0 );
   $hbox = new Gtk2::HBox( 0, 5 ); 
   $label = new Gtk2::Label("\n   ".$LANG[170]."          "); 
   $hbox->pack_start( $label,0, $true, 0 );
   my  $adj1 = Gtk2::Adjustment->new( Functions::GetAumixVolume($AUMIX,"-v")  , 0.0  , 101.0  , 0.1  , 1.0  , 1.0  ) ;
   my $vscale1 = Gtk2::HScale->new( $adj1 ) ;
   $hbox->pack_start( $vscale1,1, $true, 0 );
   $vbox2->pack_start( $hbox,0, $true, 0 ); 
   
   $hbox = new Gtk2::HBox( 0, 5 ); 
   $label = new Gtk2::Label("\n   ".$LANG[171]."  "); 
   $hbox->pack_start( $label,0, $true, 0 );
   my $adj2 = Gtk2::Adjustment->new( Functions::GetAumixVolume($AUMIX,"-m")  , 0.0  , 101.0  , 0.1  , 1.0  , 1.0  ) ;
   $vscale1 = Gtk2::HScale->new( $adj2 ) ;
   $hbox->pack_start( $vscale1,1, $true, 0 );
   $vbox2->pack_start( $hbox,0, $true, 0 ); 
   
   $hbox = new Gtk2::HBox( 0, 5 ); 
   $label = new Gtk2::Label("\n   ".$LANG[172]."       "); 
   $hbox->pack_start( $label,0, $true, 0 );
   my $adj3 = Gtk2::Adjustment->new( Functions::GetAumixVolume($AUMIX,"-c")  , 0.0  , 101.0  , 0.1  , 1.0  , 1.0  ) ;
   $vscale1 = Gtk2::HScale->new( $adj3 ) ;
   $hbox->pack_start( $vscale1,1, $true, 0 );
   $vbox2->pack_start( $hbox,0, $true, 0 ); 
   $label = new Gtk2::Label("\n");
   $vbox2->pack_start( $label,0, $true, 0 );
   
   $frame1->add( $vbox2 ); 
   $vbox->pack_start( $frame1,0, $true, 0 );
   
   $frame1 = new Gtk2::Frame();
   $frame1->set_border_width(15);
   $vbox2 = new Gtk2::VBox( 0, 5 );
   my  $button = Gtk2::Button->new($LANG[173]) ;
   $button->signal_connect('clicked', sub {
					my $vol = $adj1->value;
					my $micro = $adj2->value;
					my $cd = $adj3->value;
					Functions::SetAumixVolume($AUMIX,$vol,$micro,$cd);
					} ) ;
					
   $vbox2->pack_start( $button,0, $true, 0 );
   $frame1->add( $vbox2 ); 
   $vbox->pack_start( $frame1,0, $true, 0 );
   
   $frame->add( $vbox );
   $label = new Gtk2::Label( $LANG[174] );
   $notebook->append_page( $frame, $label );

print("..");
}
#--------------------------Disques-----------------------------------------------
   $frame = new Gtk2::Frame( $LANG[41] );
   $frame->set_size_request(800 ,500) ;  
     
   $frame->show();
   $vbox = new Gtk2::VBox( 0, 5 ); 
   my $scrolled_window = new Gtk2::ScrolledWindow( undef, undef ); #Creation d'une Scrolled Window (Fenetre avec les barres defilantes)
   $vbox->pack_start( $scrolled_window, $true, $true, 0 ); #On ajoute la Scrolled Window dans la Box a alignement Verticale
   $scrolled_window->set_policy( 'automatic', 'always' ); #la barre horizontale sera automatique et la Verticale sera toujours visible
   $scrolled_window->show();
   my $clist = Gtk2::SimpleList->new ( #Creation d'une Liste d'lment , en y mettant plusieurs colonnes , on a donc une Table
                'Filesystem                              '    => 'text', #La syntaxe pour une colonne : 'NomdelaColonne' => 'Type',
                'Type        ' => 'text',
		'1K-blocks   '  => 'text',				 #ect... ;) 
		'Used        '    => 'text',
                'Available   '  => 'text',
		'Use%'    => 'text',
                'Mounted on'  => 'text',
		);
   $scrolled_window->add( $clist ); #On met la liste dans un scrolled Window 
   $clist->show();
   $frame->add( $vbox ); #On ajoute la Box dans la Frame comme precedement ect... :) 
   my @disk = Functions::disk($DF);
   my $cmp = 1;
   my @ligne;
   while (@disk != $cmp ) {
        @ligne = split (" ",$disk[$cmp]);
   	 push @{$clist->{data}}, [@ligne] ;
	$cmp = $cmp+1;
   }
   $label = new Gtk2::Label( $LANG[42] );
   $notebook->append_page( $frame, $label );
      
print("..");
#--------------------------Reseaux-----------------------------------------------
   $frame = new Gtk2::Frame( $LANG[43] );
   $frame->set_size_request(800 ,500) ;  
     
   $frame->show();

   $vbox = new Gtk2::VBox( 0, 5 ); 
   my $scrolled_window2 = new Gtk2::ScrolledWindow( undef, undef );
   $vbox->pack_start( $scrolled_window2, $true, $true, 0 );
   $scrolled_window->set_policy( 'automatic', 'always' );
   $scrolled_window->show();
   my $clist2 = Gtk2::SimpleList->new (
                'Name                    '    => 'text',
                'IP Addr             '  => 'text',
		'Mask                '  => 'text',
		'In (kB)             ' => 'text',
		'Out (kB)            ' => 'text'
		);
   my $tooltips = Gtk2::Tooltips->new();  
   $tooltips->set_tip ( $clist2 , $LANG[44] , "" ) ; 
   $scrolled_window2->add( $clist2 );
   $clist2->show();
   $frame->add( $vbox );
   my $cmpR = 0;
   my @int = Functions::interface($IFCONFIG,$GREP);
   foreach (@int) {
   	my @InOut = GetInOutFor($int[$cmpR][0]);
   	push @{$clist2->{data}},[ $int[$cmpR][0], $int[$cmpR][1], $int[$cmpR][2], $InOut[0], $InOut[1]];
   	$cmpR = $cmpR +1;
   }
   $clist2->signal_connect(button_press_event => \&onclickList2);
   $label = new Gtk2::Label( $LANG[45] );
   $notebook->append_page( $frame, $label );

print("..");

#----------------------------Table route----------------------------------------------
    $frame = new Gtk2::Frame($LANG[46]);
    $frame->set_size_request(800 ,500) ; 
    $frame->show();
    
    $vbox = new Gtk2::VBox( 0, 5 ); 
    $scrolled_window2 = new Gtk2::ScrolledWindow( undef, undef );
    $vbox->pack_start( $scrolled_window2, $true, $true, 0 );
    $scrolled_window->set_policy( 'automatic', 'always' );
    $scrolled_window->show();
    
    my $clist3 = Gtk2::SimpleList->new (
                'Destination                   '    => 'text',
                'Gateway         '  => 'text',
		'Mask                '  => 'text',
		'Flags' => 'text',
		'Metric' => 'text',
		'Ref' => 'text',
		'Use' => 'text',
		'Int' => 'text',
		);
   my @result = Functions::route($ROUTE);
   my $rcmp = 0;
   foreach (@result) {
   	push @{$clist3->{data}},[ $result[$rcmp][0],$result[$rcmp][1],$result[$rcmp][2],$result[$rcmp][3],$result[$rcmp][4],$result[$rcmp][5],$result[$rcmp][6],$result[$rcmp][7] ];
   	$rcmp += 1;
   }		
   $scrolled_window2->add( $clist3 );
   $clist3->show();
   $frame->add( $vbox );
   $label = new Gtk2::Label( $LANG[47] );
   $notebook->append_page( $frame, $label );

#----------------------------XServeur------------------------------------------------

    $frame = new Gtk2::Frame();
    $frame->set_size_request(800 ,500) ; 
    $frame->show();

    $vbox = new Gtk2::VBox( 0, 5 );
    my $img = Gtk2::Image->new_from_file ($file."images/xlogo.jpg"); #Ici je cree une image a partir d'un fichier, rien de bien complique ;)
    $vbox->pack_start( $img,0, $true, 0 ); #On ajoute l'image dans la box a alignement verticale comme un label ou n'importe quel autre lment
    my @XServer = Functions::XServer($X,$GREP,$AWK);
    $label = new Gtk2::Label( "\n".$LANG[115]." ".$XServer[0]);
    $vbox->pack_start( $label,0, $true, 0 );
    $label = new Gtk2::Label( $LANG[116]." ".$XServer[1]);
    $vbox->pack_start( $label,0, $true, 0 );
    $label = new Gtk2::Label( $LANG[117]."".Functions::Xinfo("dimensions:",$X,$GREP)."pixels");
    $vbox->pack_start( $label,0, $true, 0 );
    $frame->add( $vbox );
    
    $label = new Gtk2::Label( $LANG[114] );
    $notebook->append_page( $frame, $label );
print(".."); 
#----------------------------Nvidia----------------------------------------------
my $labelntC;
my $labelntA;
if ($nv == $true) {
   $frame = new Gtk2::Frame(  );
   $frame->set_size_request(800 ,500) ;  
     
   $frame->show();
   $vbox = new Gtk2::VBox( 0, 5 );
   my $img = Gtk2::Image->new_from_file ($file."images/nvidia_logo.xpm");
   $vbox->pack_start( $img,0, $true, 0 );
   $labelntC = new Gtk2::Label( "\n".$LANG[49]." ".Functions::Nvidia("gpucoretemp",$NVIDIA)."0 C\n" );
   $vbox->pack_start( $labelntC,0, $true, 0 );
   $labelntA = new Gtk2::Label( $LANG[50]." ".Functions::Nvidia("GPUAmbientTemp",$NVIDIA)."0 C\n" );
   $vbox->pack_start( $labelntA,0, $true, 0 );
   my $VideoRam = Functions::Nvidia("VideoRam",$NVIDIA);
   $VideoRam =~ s/\./ kB/;
   $label = new Gtk2::Label( $LANG[51]." ".$VideoRam."\n" );
   $vbox->pack_start( $label,0, $true, 0 );
   $label = new Gtk2::Label( $LANG[52]." ".Functions::TwinView($NVIDIA)."\n\n");
   $vbox->pack_start( $label,0, $true, 0 );
   my $button = Gtk2::Button->new($LANG[53]);
   $vbox->pack_start( $button,0, $true, 0 );
   $button->signal_connect("clicked" => sub { defined(my $pid = fork)   or die "Can't fork: $!"; if ($pid != 0) { exec($NVIDIA);}});
   $frame->add( $vbox );
  
   $label = new Gtk2::Label( $LANG[54] );
   $notebook->append_page( $frame, $label );
   if ($tray == 1) {
   	$traymsg .= "\nNv Core :  ".Functions::Nvidia("gpucoretemp",$NVIDIA)."0 C\nNv Amb : ".Functions::Nvidia("GPUAmbientTemp",$NVIDIA)."0 C";
   }
}  
print("..");
#-----------------------------KDE-----------------------------------------------
if ($kdev == $true) {
	 $frame = new Gtk2::Frame(  );
    	 $frame->set_size_request(800 ,500) ; 
     
  	 $frame->show();
   	 $vbox = new Gtk2::VBox( 0, 5 );
	 my $img2 = Gtk2::Image->new_from_file ($file."images/KDE_logo.xpm");
         $vbox->pack_start( $img2,0, $true, 0 );
	 $label = new Gtk2::Label( "\n".$LANG[55]." ".Functions::KdeVer("KDE",$KDE,$GREP,$SED) );
   	 $vbox->pack_start( $label,0, $true, 0 );
	 $label = new Gtk2::Label( $LANG[56]." ".Functions::KdeVer("Qt",$KDE,$GREP,$SED) );
   	 $vbox->pack_start( $label,0, $true, 0 );
	 $label = new Gtk2::Label( $LANG[57]." ".Functions::KdeVer("kde-config",$KDE,$GREP,$SED) );
   	 $vbox->pack_start( $label,0, $true, 0 );
	 $frame->add( $vbox );
	 
	 $label = new Gtk2::Label( $LANG[58] );
   	 $notebook->append_page( $frame, $label );

}
print("..");

#----------------------------Gnome----------------------------------------------
if (-e $GNOME) {
	$frame = new Gtk2::Frame(  );
    	$frame->set_size_request(800 ,500) ; 
     
	 my $vbox = new Gtk2::VBox( 0, 5 );
	 my $img3 = Gtk2::Image->new_from_file ($file."images/gnome_logo.xpm");
         $vbox->pack_start( $img3,0, $true, 0 );
	 my @GV = Functions::GnomeVersion($HEAD,$GREP); 
	 $label = new Gtk2::Label( "\n".$LANG[59]." ".$GV[0].".".$GV[1].".".$GV[2] );
   	 $vbox->pack_start( $label,0, $true, 0 );
	 $frame->add( $vbox );
	
  	$frame->show();
	$label = new Gtk2::Label( $LANG[60] );
   	$notebook->append_page( $frame, $label );
}
#-----------------------------Mmoire--------------------------------------------
   $frame = new Gtk2::Frame($LANG[61]);
   $frame->set_size_request(800 ,500) ; 
     
   $frame->show();
   $vbox = new Gtk2::VBox( 0, 5 );
   
   $frame1 = new Gtk2::Frame($LANG[62]);
   $frame1->set_border_width(25);
   $vbox2 = new Gtk2::VBox( 0, 5 );
   my $valeur = Functions::mem("MemTotal",$CAT,$GREP);
   my ($max,$brol) = split (" ",$valeur);
   $label = new Gtk2::Label( "\n".$LANG[63]." ".$valeur);
   $vbox2->pack_start( $label,0, $true, 0 );
   $valeur = Functions::mem("MemFree",$CAT,$GREP);
   (my $min,$brol) = split(" ",$valeur);
   my $freeMlabel = new Gtk2::Label( $LANG[64]." ".$valeur);
   $vbox2->pack_start( $freeMlabel,0, $true, 0 );
   my $pbar = Gtk2::ProgressBar->new;
   my $fract = $min/$max;
   $pbar->set_fraction($fract);
   $pbar->set_text((roundpos($fract*100))."% Free");
   $vbox2->pack_start( $pbar,0, $true, 0 );
   $frame1->add($vbox2);
   
   my $frame2 = new Gtk2::Frame($LANG[65]);
   $frame2->set_border_width(25);
   $vbox2= new Gtk2::VBox( 0, 5 );
   $valeur = Functions::mem("SwapTotal",$CAT,$GREP);
   ($max,$brol) = split (" ",$valeur);
   $label = new Gtk2::Label( $LANG[66]." ".$valeur);
   $vbox2->pack_start( $label,0, $true, 0 );
   $valeur = Functions::mem("SwapFree",$CAT,$GREP);
   ($min,$brol) = split (" ",$valeur);
   my $freeSlabel = new Gtk2::Label( $LANG[67]." ".$valeur );
   $vbox2->pack_start( $freeSlabel,0, $true, 0 );
   my $pbar2 = Gtk2::ProgressBar->new;
   $fract = $min/$max;
   $pbar2->set_fraction($fract);
   $pbar2->set_text((roundpos($fract*100))."% Free");   
   $vbox2->pack_start( $pbar2,0, $true, 0 );
   $frame2->add($vbox2);
   
   $vbox->pack_start( $frame1,0, $true, 0 );
   $vbox->pack_start( $frame2,0, $true, 0 );
   $frame->add( $vbox );
   
   $label = new Gtk2::Label( $LANG[61] );
   $notebook->append_page( $frame, $label );

print("..");

#-----------------------------ACPI-----------------------------------------------
my $acpilabel;
my $batterieP = $false;
my $BatEtat;
my $BatRes;
my $PBatEtat;
my $BatMax;
my $tempnum;
my $batnum = 0;
if ($acpi == $true) {
    $frame = new Gtk2::Frame($LANG[68]);
    $frame->set_size_request(800 ,500) ; 
    my $link; 
    $frame->show();
    $vbox = new Gtk2::VBox( 0, 5 );
    my $batterie = "/proc/acpi/battery/";
    if (-e $batterie) {
        $frame2 = new Gtk2::Frame($LANG[69]);
        $frame2->set_border_width(25);
	$vbox2 = new Gtk2::VBox( 0, 5 );
	my $link = "/proc/acpi/battery/BAT$batnum/state";
	while ((! -e $link) and ($batnum < 11)) {
	
		$batnum +=1;
		$link = "/proc/acpi/battery/BAT$batnum/state";
		
	}
	if (-e $link) { 
	        my $presence =  Functions::acpinfo($link,"present:",$CAT,$GREP);
		my $tp = $presence;
		$presence =~ s/yes/$LANG[166]/o;
		$presence =~ s/no/$LANG[167]/o;
		chomp($presence);
    		$label = new Gtk2::Label("\n".$LANG[118]." ".$presence."\n");
   		$vbox2->pack_start( $label,0, $true, 0 );
		if ($tp =~ /.*yes*./) {
			$batterieP = $true;
		        my $etat = Functions::acpinfo($link,"charging",$CAT,$GREP);
			$etat =~ s/charged/$LANG[70]/o;
			$etat =~ s/discharging/$LANG[71]/o;
			$etat =~ s/charging/$LANG[72]/o;
			$BatEtat = new Gtk2::Label( $LANG[73]." ".$etat);
   			$vbox2->pack_start( $BatEtat,0, $true, 0 );
			my $Et = Functions::acpinfo($link,"remaining",$CAT,$GREP);
			chomp($Et);
			$BatRes = new Gtk2::Label( $LANG[74]." ".$Et."\n" );
   			$vbox2->pack_start( $BatRes,0, $true, 0 );
			$link = "/proc/acpi/battery/BAT$batnum/info";
			my $Max = Functions::acpinfo($link,"full",$CAT,$GREP);
			chomp($Max);
			$BatMax = new Gtk2::Label( $LANG[75]." ".$Max."\n" );
   			$vbox2->pack_start( $BatMax,0, $true, 0 );
			$Max =~ s/mWh//o;
			$Et =~ s/mWh//o;
			my $Pourc = $Max / $Et;
			$Pourc = 100 / $Pourc; 
			$Pourc = round($Pourc);
			$traymsg .= "\n".$LANG[163]." : ".$Pourc."%"; 
			$PBatEtat = new Gtk2::Label( $LANG[76]." ".$Pourc."%\n");
			$vbox2->pack_start( $PBatEtat,0, $true, 0 );
		}
	}		
	}
	$frame2->add($vbox2);
	$vbox->pack_start( $frame2,0, $true, 0 );
    
    my $thermal = "/proc/acpi/thermal_zone/";
    if (-e $thermal) {
        $frame1 = new Gtk2::Frame($LANG[77]);
        $frame1->set_border_width(25);
	$vbox2 = new Gtk2::VBox( 0, 5 );
	$tempnum = 0;
	my $link = "/proc/acpi/thermal_zone/THM$tempnum/temperature";
	while ((! -e $link) and ($tempnum < 11)) {
		$link = "/proc/acpi/thermal_zone/THM$tempnum/temperature";
		$tempnum +=1;
	}
	if ($tempnum == 11) {
		$link = "/proc/acpi/thermal_zone/THRM/temperature";
	}
	if (-e $link) { 
    		$acpilabel = new Gtk2::Label( "\n".$LANG[78]." ".Functions::acpinfo($link,"temperature:",$CAT,$GREP)."\n" );
   		$vbox2->pack_start( $acpilabel,0, $true, 0 );
		$acpitemp1 = $true;
		my $temp = Functions::acpinfo($link,"temperature:",$CAT,$GREP);
		chomp($temp);
		$traymsg .= "\nTemp 1(acpi) : ".$temp;
	}
	
	$frame1->add($vbox2);
	$vbox->pack_start( $frame1,0, $true, 0 );
    }
  
    $frame->add( $vbox );
    $label = new Gtk2::Label( $LANG[79] );
    $notebook->append_page( $frame, $label );
print("..");    
}
#-----------------------------Linux----------------------------------------------
   $frame = new Gtk2::Frame($LANG[80]);
   $frame->set_size_request(800 ,500) ; 
     
   $frame->show();
   $vbox = new Gtk2::VBox( 0, 5 );
    
   
   $label = new Gtk2::Label( "\n"."Hostname : ".Functions::hostname($HOST)."\n" );
   $vbox->pack_start( $label,0, $true, 0 );
   my $Uptimelabel = new Gtk2::Label( $LANG[81]." ".Functions::uptime($UPTIME)."\n" );
   $vbox->pack_start( $Uptimelabel,0, $true, 0 );
   $label = new Gtk2::Label( $LANG[119]." ".Functions::version($CAT)."\n" );
   $vbox->pack_start( $label,0, $true, 0 );
   $hbox = new Gtk2::HBox( 0, 5 );
   my ($distro,$imaged) = Functions::Distro($CAT); 
   chomp($distro);
   $label = new Gtk2::Label( $LANG[82]." ".$distro."  ");
   $vbox->pack_start( $label,0, $true, 0 );
   if ($imaged ne "none") {
   	my $imgdistro = Gtk2::Image->new_from_file ($file."images/".$imaged);
   	$vbox->pack_start( $imgdistro,0, $true, 0 );
   }
   $frame->add( $vbox );
     
   $label = new Gtk2::Label( $LANG[80] );
   $notebook->append_page( $frame,$label);


#---------------------------Autres-----------------------------------------------
   $frame = new Gtk2::Frame($LANG[83]);
   $frame->set_size_request(800 ,500) ; 
     
   $frame->show();
   $vbox = new Gtk2::VBox( 0, 5 );

   my @gcc = Functions::Gcc($GCC);
   $label = new Gtk2::Label( "\n".$LANG[84]." ".$gcc[0]." built for ".$gcc[1]);
   $vbox->pack_start( $label,0, $true, 0 );
   $label = new Gtk2::Label( $LANG[85]." ".Functions::Perl($PERL,$GREP));
   $vbox->pack_start( $label,0, $true, 0 );
   if ($alsactl == $true) {
   	$label = new Gtk2::Label( $LANG[86]." ".Functions::AlsaVersion($ALSA));
   	$vbox->pack_start( $label,0, $true, 0 );
   }
   if (-e $ICEWM) {
   $label = new Gtk2::Label( $LANG[87]." ".Functions::IceWmVersion($ICEWM));
   $vbox->pack_start( $label,0, $true, 0 );
   }
   if (-e $FLUXBOX) {
        if (`$FLUXBOX -v 2>&1` =~ /.*error.*/) {
		$label = new Gtk2::Label( $LANG[88]." ".$LANG[89]);
       		$vbox->pack_start( $label,0, $true, 0 );
		logmsg($LANG[90]);
	} else {
   		$label = new Gtk2::Label( $LANG[88]." ".Functions::fluxinfo("Fluxbox",$FLUXBOX,$GREP));
       	 	$vbox->pack_start( $label,0, $true, 0 );
	}
   }
   if ($GLIB ne "Not Found") {
   	$label = new Gtk2::Label( "\nGLIB : ".Functions::glib($GLIB));
   	$vbox->pack_start( $label,0, $true, 0 );
   }
   $frame->add( $vbox );
   
   $label = new Gtk2::Label( $LANG[92] );
   $notebook->append_page( $frame, $label );

print("..");

#-----------------------StatusBar------------------------------------------------
my  $statusbar = Gtk2::Statusbar->new() ;
$table->attach_defaults($statusbar, 0, 6, 2, 3 ); #Ajout de la barre de Status dans la Table (elle prendra 6 colonnes et 1 Ligne)
$statusbar->show() ;
my $context_id = $statusbar->get_context_id("...") ; #Je recupere l'identification ce qui me permet d'ajouter d'autres messages par la suite 
#------------------------Timer---------------------------------------------------
if ($refresh == 1) {
	my $horloge = Glib::Timeout->add( $millisec, \&Refresh,""); #Cration d'une Timer (horloge) , elle appelera la methode Refresh toutes les 10000 millisecondes 
						       #ce qui quivaut a 10 secondes , modifier le timer en fonction de la mthode appele pour eviter
						       #de freezer l'application ;)
						       
} else {
	$statusbar->push($context_id,$LANG[164]) ; 
}
 
#--------------------------------------------------------------------------------
print ($LANG[93]."\n"); 
   
$window->show_all();
if ($tray == 1) {		
		$tooltipstray->set_tip( $icontray ,$traymsg, ""); 
	}

main Gtk2; #Boucle Gtk2

#-----------------------------Procedure appel par le Timer----------------------
sub Refresh {
$traymsg = $LANG[94];
if ($nv == $true || $sens == $true) {
if ($sens == $true) {
   	$labelTCPU->set_label($LANG[29]." : ".Functions::SensorsTemp($CPUSensors,$SENSORS,$GREP)."\n" );
	$labelTB->set_label($LANG[30]." ".Functions::SensorsTemp($BoitierSensors,$SENSORS,$GREP)."\n");
	$labelTV1->set_label($LANG[32]." 1 : ".Functions::SensorsTemp("fan1:",$SENSORS,$GREP)." RPM\n");
	$labelTV2->set_label($LANG[32]." 2 : ".Functions::SensorsTemp("fan2:",$SENSORS,$GREP)." RPM\n");
	if ($tray == 1) {
		$traymsg = "CPU : ".Functions::SensorsTemp($CPUSensors,$SENSORS,$GREP)."\n"."Tower : ".Functions::SensorsTemp($BoitierSensors,$SENSORS,$GREP);
	}
}
if ($nv == $true) {
	$labelntC->set_label( "\n".$LANG[49]." ".Functions::Nvidia("gpucoretemp",$NVIDIA)."0 C\n" );
	$labelntA->set_label( $LANG[50]." ".Functions::Nvidia("GPUAmbientTemp",$NVIDIA)."0 C\n");
	if ($tray == 1) {
   	$traymsg .= "\nNv Core :  ".Functions::Nvidia("gpucoretemp",$NVIDIA)."0 C\nNv Amb : ".Functions::Nvidia("GPUAmbientTemp",$NVIDIA)."0 C";
        }
}
}
if ($acpitemp1 == $true) {
	my $link;
	if ($tempnum == 11) {
		$link = "/proc/acpi/thermal_zone/THRM/temperature";
	} else {
		$link = "/proc/acpi/thermal_zone/THM$tempnum/temperature";
	}
        $acpilabel->set_label("\n".$LANG[78]." ".Functions::acpinfo($link,"temperature:",$CAT,$GREP)."\n" );
	my $temp = Functions::acpinfo($link,"temperature:",$CAT,$GREP);
	chomp($temp);
	$traymsg .= "\nTemp 1(acpi) : ".$temp;
}
if ($batterieP == $true) {
	my $link = "/proc/acpi/battery/BAT$batnum/state";
	my $etat = Functions::acpinfo($link,"charging",$CAT,$GREP);
	$etat =~ s/charged/charge/o;
	$etat =~ s/discharging/se dcharge/o;
	$etat =~ s/charging/en charge/o;
	$BatEtat->set_label( $LANG[73]." ".$etat);
	my $Et = Functions::acpinfo($link,"remaining",$CAT,$GREP);
	chomp($Et);
	$BatRes->set_label( $LANG[74]." ".$Et."\n");
	my $Max = Functions::acpinfo("/proc/acpi/battery/BAT$batnum/info","full",$CAT,$GREP);
	$Max =~ s/mWh//o;
	$Et =~ s/mWh//o;
	my $Pourc = $Max / $Et;
	$Pourc = 100 / $Pourc; 
	$Pourc = round($Pourc); 
	$PBatEtat->set_label( $LANG[76]." ".$Pourc."%\n");
	$traymsg .= "\n".$LANG[163]." : ".$Pourc."%";
}
if ($tray == 1) {
        
	$tooltipstray->set_tip( $icontray ,$traymsg, ""); 
}
$Uptimelabel->set_label( $LANG[81]." ".Functions::uptime($UPTIME)."\n" );
$valeur = Functions::mem("MemFree",$CAT,$GREP) ;
($min,$brol) = split(" ",$valeur);
$freeMlabel->set_label( $LANG[64]." ".$valeur);
$valeur = Functions::mem("MemTotal",$CAT,$GREP);
($max,$brol) = split (" ",$valeur);
$fract = $min/$max;
$pbar->set_fraction($fract);
$pbar->set_text((roundpos($fract*100))."% Free");
$valeur = Functions::mem("SwapFree",$CAT,$GREP);
($min,$brol) = split(" ",$valeur);
$freeSlabel->set_label( $LANG[67]." ".$valeur );
$valeur = Functions::mem("SwapTotal",$CAT,$GREP);
($max,$brol) = split(" ",$valeur);
$fract = $min/$max;
$pbar2->set_fraction($fract);
$pbar2->set_text((roundpos($fract*100))."% Free");

while ($cmpR > 0) {
  	pop @{$clist2->{data}};
	#splice @{ $clist2->{data} }, $cmpR-1, 1; #Splice n'est pas supporte sur certaines versions
	$cmpR = $cmpR -1;
}
$cmpR = 0;
   my @int = Functions::interface($IFCONFIG,$GREP);
   foreach (@int) {
   	my @InOut = GetInOutFor($int[$cmpR][0]);
   	push @{$clist2->{data}},[ $int[$cmpR][0], $int[$cmpR][1],$int[$cmpR][2] ,$InOut[0], $InOut[1]];
   	$cmpR = $cmpR +1;
   }
$statusbar->push($context_id,$LANG[159]." ".scalar localtime  ) ; 
return $true;
}


#--------------------------Fermeture du Programme---------------------------------------
sub  Destroy_Window {
	Gtk2->main_quit ; #on quitte la boucle de Gtk2 ce qui ferme l'application, logique :o 
	return $false ; 
}


#------------------------Affichage Fenetre de Dialogue pour Quitter----------------------
sub CloseAppWindow {
        #Cration d'une boite de dialogue de type Question et Yes-No (Oui -Non), cela nous affichera par default un point d'interrogation,
	#un bouton 'yes' et un bouton 'no'  
	my  $dialog = Gtk2::MessageDialog->new ($window,[qw/modal destroy-with-parent/],'question','yes-no',$LANG[127]); 
	if ($dialog->run eq 'yes') { #Si l'utilisateur clique sur le bouton 'yes',
		Destroy_Window();    #on appelle la methode qui va quitter l'application.
		return $false;
	} else {
		$dialog->destroy; #sinon on detruit juste la boite de dialogue et on reste dans l'appli
		return $true;
	}
} 


#-----------------------------Log des messages dans un fichier--------------------------
sub logmsg {
        my $message = shift;
        open(FILE, ">> $LOGPATH")
            or die $LANG[95]." $LOGPATH";
        print FILE ("-----------------------------[",scalar localtime,"]-----------------------------\n");
        print FILE ($message."\n");
        print FILE ("------------------------------------------------------------------------------------\n");
        close(FILE);
}

#-------------------------Fenetre A Propos----------------------------------------------
sub About {
my $window = Gtk2::Window->new( "toplevel" );
$window->set_position("center");
$window->set_title($LANG[120]);
$window->set_icon_from_file($file."images/icon2.png");
$window->set_default_size( 250,150  );
$window->realize();
my $vbox = new Gtk2::VBox( 0, 5 );
$window->add($vbox);
my $label = new Gtk2::Label( "\n".$LANG[96]." Pissens Sbastien");
$vbox->pack_start( $label,0, $true, 0 );
$label = new Gtk2::Label( $LANG[97]." 2004");
$vbox->pack_start( $label,0, $true, 0 );
$label = new Gtk2::Label( $LANG[98]." GtkSysinfo");
$vbox->pack_start( $label,0, $true, 0 );
$label = new Gtk2::Label( $LANG[116]." $Version");
$vbox->pack_start( $label,0, $true, 0 );
$label = new Gtk2::Label( $LANG[99]." GNU/GPL\n");
$vbox->pack_start( $label,0, $true, 0 );
$label = new Gtk2::Label( "GtkSysinfo ".$LANG[100]);
$vbox->pack_start( $label,0, $true, 0 );
my $text = Gtk2::TextView->new;
    	$text->show;
    	$text->set_editable($false);
    	$text->set_cursor_visible($false);
	$text->set_border_width (10);
	my $textbuffer = Gtk2::TextBuffer->new(undef);
	$textbuffer->insert_at_cursor(" http://gtk2-perl.sourceforge.net/doc/pod/ \n\n http://perso.wanadoo.fr/gtk2-perl/Gtk2perl_tutoriel.html \n\n http://gtk2-perl.sourceforge.net/doc/gtk2-perl-tut/ ");
	$text->set_buffer($textbuffer);
$vbox->pack_start( $text,0, $true, 0 );
$window->show_all();
}


#--------------------Fenetre de la Licence GNU/GPL--------------------------------------
sub Licence {
my $window = Gtk2::Window->new( "toplevel" );
$window->set_position("center");
$window->set_title( $LANG[158] );
$window->set_icon_from_file($file."images/icon2.png");
$window->set_default_size( 480, 280 );
$window->realize();
my $text = new Gtk2::Label( "                                      GNU/GPL Licence

Copyright GtkSysinfo Pissens Sbastien

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.");
$window->add($text);
$window->show_all();
}




#-----------------Methode pour arrondire les nombre-----------------------------------
sub round {
    my($number) = shift;
    return int($number - 0.5);
}

sub roundpos {
    my($number) = shift;
    return int($number + 0.5);
}

#--------------------Renvois le In et le Out d'une interface Reseau donne-----------------------
sub GetInOutFor {
	my $param = shift;
        my $inout = `$CAT /proc/net/dev | $GREP $param`;
	$inout =~ s/:/ /gi;
	$inout =~ s/ * /;/gi;
	my ($in,$out,@brol2,$brol);
	($brol,$brol,$in,$brol,$brol,$brol,$brol,$brol,$brol,$brol,$out,@brol2) = split(";",$inout);
	$in = $in / 1024;
	$in = round($in);
	$out = $out / 1024;
	$out = round($out);
        return ($in,$out);
}


sub onclickList2 {
    my ($widget, $event) = @_;
    
    if ($event->type() eq 'button-press' && $event->button() == 3) {
	my ($x,$y) = $event->get_coords;
	my ($path, $column, $px, $py) = $widget->get_path_at_pos($x,$y);

	my $menu = Gtk2::Menu->new();

	my $menuitem1 = Gtk2::MenuItem->new($LANG[121]);
	my $menuitem3 = Gtk2::MenuItem->new($LANG[122]);
	my $menuitem2 = Gtk2::MenuItem->new($LANG[123]);
	

	$menuitem1->signal_connect(activate =>sub { intDown($widget,$path);});
	$menuitem2->signal_connect(activate =>sub { ChangeInt($widget,$path);});
	$menuitem3->signal_connect(activate =>sub { intUp(); });
	
	$menuitem1->show();
	$menuitem2->show();
	$menuitem3->show();
	
	$menu->append($menuitem1);
	$menu->append($menuitem3);
	$menu->append($menuitem2);
	
	$menu->popup(undef,undef,undef,undef,$event->button,$event->time);
	}
	return 0;
    }

sub intUp {
	my $window = Gtk2::Window->new( "toplevel" );
	$window->set_position("center");
	$window->set_title($LANG[124]);
	$window->set_icon_from_file($file."images/icon.png");
	$window->set_border_width( 15  ) ; 
	$window->set_resizable($false);
	$window->realize();
	
	my $frame = new Gtk2::Frame();
        $frame->set_size_request(260 ,150);      
 
	
	my  $vbox = Gtk2::VBox->new( $false, 5  ) ;
	$vbox->show() ;
	my $label = Gtk2::Label->new ($LANG[125]);
	$vbox->add($label);  
	my $entry = Gtk2::Entry->new();
	
	my $hbox = Gtk2::HBox->new( $true, 15  ) ;
	my $button = Gtk2::Button->new($LANG[104]);
	my $button2 = Gtk2::Button->new($LANG[105]);
	
	$button->signal_connect( "clicked"  , sub { $window->destroy(); } ) ; 
	$button2->signal_connect( "clicked"  , sub { 
						     my $int = $entry->get_text();
						     IpUpNow($int);
						     $window->destroy;
						    } 
				) ; 
	
	$hbox->add($button);
	$hbox->add($button2);
	
	$vbox->add($entry);
	$frame->add( $vbox );
	$vbox->add($hbox);
	$window->add( $frame );
	$window->show_all();
	   
	
}
 
sub IpUpNow {
    my $int = shift;
    my $retour = `$IFCONFIG $int up 2>&1`;
    if ($retour =~ /.*Permission denied.*/) {
       my $dialog = Gtk2::MessageDialog->new($window,[qw/modal destroy-with-parent/],'error','ok',$LANG[106]);
       $dialog->add_button($LANG[21] ,'help') ; 
   	if ($dialog->run eq 'help') {
		NoAccessHelp();		
	}
	$dialog->destroy;
   }
}

sub intDown {
    my ($widget,$path) = @_;
    my $data = $widget->get_row_data_from_path($path);
    my $int = ${$data}[0];
    my $retour = `$IFCONFIG $int down 2>&1`;
    if ($retour =~ /.*Permission denied.*/) {
       my $dialog = Gtk2::MessageDialog->new($window,[qw/modal destroy-with-parent/],'error','ok',$LANG[106]);
       $dialog->add_button($LANG[21] ,'help') ; 
   	if ($dialog->run eq 'help') {
	        $dialog->destroy;
		NoAccessHelp();	
	} else {
		$dialog->destroy;
	}
    }
}


sub NoAccessHelp {
my $window = Gtk2::Window->new( "toplevel" );
$window->set_position("center");
$window->set_title($LANG[126] );
$window->set_icon_from_file($file."images/icon2.png");
my $text = new Gtk2::Label( "

    ".$LANG[160]."    
    ".$LANG[161]."    

    ".$LANG[162]." 
");
$window->add($text);
$window->show_all();
}

sub ChangeInt {
	 my ($widget,$path) = @_;
	 my $data = $widget->get_row_data_from_path($path);
	 my $int = ${$data}[0];
	 my $ip = ${$data}[1];
	 my $mask = ${$data}[2];
	 my $window = Gtk2::Window->new( "toplevel" );
	$window->set_position("center");
	$window->set_title($LANG[101]." ".$int);
	$window->set_icon_from_file("images/icon.png");
	$window->set_border_width( 15  ) ; 
	$window->set_resizable($false);
	$window->realize();
	
	my $frame = new Gtk2::Frame();
        $frame->set_size_request(260 ,150);      
 
	
	my  $vbox = Gtk2::VBox->new( $false, 5  ) ;
	$vbox->show() ;
	my $label = Gtk2::Label->new ($LANG[102]);
	$vbox->add($label);  
	my $entry = Gtk2::Entry->new();
	$entry->set_text($ip) ; 
	
	$label = Gtk2::Label->new ($LANG[103]);
	my $entry2 = Gtk2::Entry->new();
	$entry2->set_text($mask) ;
	
	my $hbox = Gtk2::HBox->new( $true, 15  ) ;
	my $button = Gtk2::Button->new($LANG[104]);
	my $button2 = Gtk2::Button->new($LANG[105]);  
	
	$button->signal_connect( "clicked"  , sub { AnnuleConfig($window); } ) ; 
	$button2->signal_connect( "clicked"  , sub { 
							my $ip = $entry->get_text();
							my $mask = $entry2->get_text();
							ConfirmeConfig($window,$int,$ip,$mask); 
						   }
				 ) ; 
	
	$hbox->add($button);
	$hbox->add($button2);
	
	$vbox->add($entry);
	$vbox->add($label);  
	$vbox->add($entry2);
	$vbox->add($hbox);
	
	$frame->add( $vbox ) ;
	$window->add( $frame );
	$window->show_all();
}
    
sub AnnuleConfig {
	my $window = shift;
	$window->destroy;
}

sub ConfirmeConfig {
	my ($window,$int,$ip,$mask) = @_;
	$window->destroy;
	my $retour = 1;
	$retour = `$IFCONFIG $int $ip netmask $mask 2>&1`;
	if ($retour =~ /.*Permission denied.*/) {
            my $dialog = Gtk2::MessageDialog->new($window,[qw/modal destroy-with-parent/],'error','ok',$LANG[106]);
           $dialog->add_button($LANG[21] ,'help') ; 
           if ($dialog->run eq 'help') {
		NoAccessHelp();		
	   }
	  $dialog->destroy;
       }
}

sub InitFunctions {
	my @CatDesc = ( 
			[ $LANG[128]." ".$LANG[129], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[140]." ".$LANG[141] ],
			[ $LANG[128]." ".$LANG[130], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[140]." ".$LANG[142] ],
			[ $LANG[128]." ".$LANG[131], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[140]." ".$LANG[143] ],
			[ $LANG[128]." ".$LANG[132], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[140]." ".$LANG[144] ],
			[ $LANG[128]." ".$LANG[133], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[145]." ".$LANG[146] ],
			[ $LANG[134]." ".$LANG[135], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[145]." ".$LANG[147] ],
			[ $LANG[134]." ".$LANG[136], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[145]." ".$LANG[148] ],
			[ $LANG[137], "\n ".$LANG[138]."\n ----------------\n\n ".$LANG[139]." ".$LANG[145]." ".$LANG[149] ]
		  );
		  
	Functions::initCatDesc(@CatDesc);

	my @ProductStruct = ($LANG[150],$LANG[151],$LANG[152],$LANG[153]);
	Functions::initItemStruct(@ProductStruct);

	my @DataLang = ($LANG[154],$LANG[155],$LANG[156],$LANG[157]);
	Functions::initDataLang(@DataLang);

}

}

}
