#-------------------------------Licence GNU/GPL---------------------------------------
#Copyright Sysinfo Pissens Sbastien
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#--------------------------------------------------------------------------------------


package Functions;
use strict;

my @Constructor = (
			["ATI","www.ati.com"],
			["nVidia","www.nvidia.com"],
			["3Com","www.3com.com"],
			["Intel","www.intel.com"],
			["Cirrus Logic","www.cirrus.com"],
			["VIA Technologies","www.via.com.tw"],
			["hp","www.hp.com"],
			["NEC Corporation","www.nec.com"],
			["MAXTOR","www.maxtor.com"],
			["SAMSUNG","www.samsung.com"],
			["PIONEER","www.pioneer-eur.com"],
			["PLEXTOR","www.plextor.be"],
			["Realtek Semiconductor","www.realtek.com.tw"],
			["TOSHIBA","www.toshiba.com"],
			["LITE-ON","www.liteonit.com"],
			["WDC","www.wdc.com"],
			["ST","www.seagate.com"],
			["Lexmark","www.lexmark.com"]
		   );
my @CatDesc;
my @ProductStruct;
my @DataLang;

my @Disc = ( ["HDA","/proc/ide/hda"],
	     ["HDB","/proc/ide/hdb"],
	     ["HDC","/proc/ide/hdc"],
	     ["HDD","/proc/ide/hdd"],
	     ["HDE","/proc/ide/hde"]
	   );

sub initCatDesc {
	@CatDesc = @_;
} 

sub initItemStruct {
	@ProductStruct = @_;
}

sub initDataLang {
	@DataLang = @_;
}

sub GetAumixVolume {
	my ($command,$type) = @_;
	my $result = `$command $type q`;
	my $brol;
	($brol,$result,$brol) = split(",",$result);
	return $result;
}

sub SetAumixVolume {
	my ($command,$vol,$micro,$cd) = @_;
	`$command -v $vol`;
	`$command -m $micro`;
	`$command -c $cd`;
	
}
#-----------------Donnees des peripheriques------------------------------------------
sub PeriUSB {
	my ($CAT,$GREP) = @_;
	my $param =  "\"Product\\|Manufacturer\"";
	my @result = `$CAT /proc/bus/usb/devices | $GREP $param`;
	my @PeriUSB;
	$PeriUSB[1] = $DataLang[0];
	$PeriUSB[0] = $DataLang[1];
	my $man = 0;
	my $cmp = 0;
	my $brol;
	foreach(@result) {
		chomp($_);
		if ($_ !~ /.*Linux.*/ && $_  !~ /.*UHCI.*/ && $_  !~ /.*OHCI.*/ && $_  !~ /.*EHCI.*/) {
			if ($man == 0) {
				if ($_ =~ /.*Manufacturer.*/) {
					($brol,$PeriUSB[$cmp]) = split("=",$_);
					$cmp += 1;
					$man = 1;
				} else {
					$PeriUSB[$cmp] = "Inconnu";
					$cmp += 1;
					($brol,$PeriUSB[$cmp]) = split("=",$_);
					$cmp += 1;
					$man = 0;
				}
				
			} elsif ($_ =~ /.*Product.*/) {
				($brol,$PeriUSB[$cmp]) = split("=",$_);
				$cmp += 1;
				$man = 0;
			}							
		}
	}
	return @PeriUSB;	
} 

sub PeriInput {
	my ($CAT,$GREP) = @_;
	my @result = `$CAT /proc/bus/input/devices | $GREP Name`;
	my @PeriInput;
	$PeriInput[0] = $DataLang[0];
	my $cmp = 0;
	my $brol;
	foreach(@result) {
		($brol,$PeriInput[$cmp]) = split("=",$_);
		$PeriInput[$cmp] =~ s/"//o;
		$PeriInput[$cmp] =~ s/"//o;
		$cmp += 1;
	}
	return @PeriInput;

}
sub InfoByProduct {
	my($cmp,@Peri) = @_;
	my $result = "none";
	foreach (@Constructor) {
		if ($Peri[$cmp-1] =~ /.*${$_}[0].*/) {
			$result = "\n ".$ProductStruct[0]." :   ".$Peri[$cmp]."\n -------\n\n ".$ProductStruct[1]." :   ".$Peri[$cmp-1]."\n ------------\n\n ".$ProductStruct[2]." :   ".${$_}[1]."\n -------------\n";
	}
	} 
	if ($result eq "none") {
		$result = "\n ".$ProductStruct[0]." :   ".$Peri[$cmp]."\n -------\n\n ".$ProductStruct[1]." :   ".$Peri[$cmp-1]."\n ------------\n\n ".$ProductStruct[2]." :   ".$DataLang[3]."\n -------------\n";
	}
	return $result;
}


sub PeriIDE {
	my $CAT = shift;
	my @result;
	$result[0] = [$DataLang[0],$DataLang[1]];
	my $cmp = 0;
	foreach (@Disc) {
		if (-e ${$_}[1]) {
			my $data = `$CAT ${$_}[1]/model`;
			$result[$cmp] = [$data,${$_}[0]];
			$cmp += 1;
		}
	}
	return @result;
}

sub DiscById {
	my @disc = @_;
	my $result = "none";
	foreach (@Constructor) {
		if ($disc[0][0] =~ /.*${$_}[0].*/) {
			$result = "\n ".$ProductStruct[0]." :   ".$disc[0][0]."\n -------\n\n ".$ProductStruct[3]." :   ".$disc[0][1]."\n ----\n\n".$ProductStruct[1]." :   ".${$_}[0]."\n ------------\n\n ".$ProductStruct[2]." :   ".${$_}[1]."\n -------------\n";
	}
	} 
	if ($result eq "none") {
		$result = "\n ".$ProductStruct[0]." :   ".$disc[0][0]."\n -------\n\n ".$ProductStruct[3]." :   ".$disc[0][1]."\n ----\n\n ".$ProductStruct[1]." :   ".$DataLang[3]."\n ------------\n\n ".$ProductStruct[2]." :   ".$DataLang[3]."\n -------------\n";
	}
	return $result;
	
}

		  
#-----------------Donnes des Cartes par lspci---------------------------------------
sub card {
	my ($command,$split) = @_;
	my @card = `$command`;
	my $nbr = @card-1;
	if ($nbr == -1) {
		$card[$nbr+1] = $DataLang[2];
	}
	while ($nbr > -1) {
		(my $brol,$card[$nbr]) = split ($split,$card[$nbr]);
		$nbr = $nbr -1;
	}
	return @card;
}

sub addtree {
   my ($command,$titre,$split,$tree_model) = @_; 
   my $iter = $tree_model->append (undef);
   $tree_model->set($iter, 0 ,$titre);
   foreach(card($command,$split)) {
   	my $citer = $tree_model->append ($iter);
	chomp($_);
   	$tree_model->set($citer, 0 ,$_);
   }
   return $tree_model;
}
		  
sub traiteCarte {
	my $item = shift;
	my $result = traiteCategorie($item);
	if ($result eq "none") {
		$result = traiteMarque($item);
	} 
	return $result;
	
}

sub traiteCategorie {
	my $item = shift;
	my $result = "none";
	foreach (@CatDesc) {
		if (${$_}[0] eq $item) {
			$result = ${$_}[1];
		}
	}
	return $result;
}

sub traiteMarque {
	my $item = shift;
	my $result = "none";
	foreach (@Constructor) {
		if ($item =~ /.*${$_}[0].*/) {
			$result = "\n ".$ProductStruct[0]." :   ".$item."\n -------\n\n ".$ProductStruct[1]." :   ".${$_}[0]."\n ------------\n\n ".$ProductStruct[2]." :   ".${$_}[1]."\n -------------\n";
		} elsif ($item =~ /.*$DataLang[2].*/) {
			$result = "\n ".$DataLang[2];
		}
	} 
	if ($result eq "none") {
		$result = "\n ".$ProductStruct[0]." :   ".$item."\n -------\n\n ".$ProductStruct[1]." :   ".$DataLang[3]."\n ------------\n\n ".$ProductStruct[2]." :   ".$DataLang[3]."\n -------------\n";
	}
	return $result;
}

#-------------Uptime------------------------------------------------------------------
sub uptime {
	my $UPTIME = shift;
        my $uptime = `$UPTIME`;
        $uptime =~ m/up\s+(.*),\s+(.*?) users?,.*:\s+(.*)/o;
        $uptime = $1;
        $uptime =~ s/:(\d\d)/ heures $1 minutes/o;
        $uptime =~ s/mins/minutes/o;
        $uptime =~ s/^1 hours/1 heure/o;
        $uptime =~ s/ 1 minutes$/1 minute/o;
	$uptime =~ s/day/jour/gi;
	$uptime =~ s/days/jours/gi;
	return $uptime;
}

#------------------Donnes du CPU----------------------------------------------------
sub cpu_info {
        my ($param,$CAT,$GREP) = @_; 
	my $freq = `$CAT /proc/cpuinfo | $GREP $param`;
	(my $brol,$freq) = split(":",$freq);
	return $freq;
}

#----------------Donnes sur la Ram--------------------------------------------------
sub mem {
        my ($param,$CAT,$GREP) = @_;
	my $mem = `$CAT /proc/meminfo | $GREP $param`;
	(my $brol,$mem) = split(":",$mem);
	return $mem;
}

#-------------------Version du Kernel-------------------------------------------------
sub version {
	my $CAT = shift;
	my $version = `$CAT /proc/version`;
	my @tab = split (" ",$version);
	return $tab[0]." ".$tab[1]." ".$tab[2];
}

#----------------les differents disques-----------------------------------------------
sub disk {
	my $DF = shift;
	my @disk = `$DF -P -l -T -h`;
	return @disk;
}

#------------------les Interfaces Reseaux---------------------------------------------
sub interface {
my ($IFCONFIG,$GREP) = @_;
my @interface = `$IFCONFIG | $GREP L*\\\ encap`;
my $cmp = 0;
my $brol;
my @brol;
foreach(@interface) {
        $interface[$cmp] =~ s/ * /;/gi;
        ($interface[$cmp],my @brol) = split(";",$interface[$cmp]);
        $cmp = $cmp +1;
}
$cmp =0;
my @ip;
foreach (@interface) {
        $ip[$cmp] = `$IFCONFIG $interface[$cmp] | $GREP dr:`;
        $ip[$cmp] =~ s/ * /;/gi;
        ($brol,$brol,$ip[$cmp],$brol) = split(";",$ip[$cmp]);
        ($brol,$ip[$cmp]) = split("dr:",$ip[$cmp]);
        $cmp = $cmp+1;
}

$cmp =0;
my @mask;
foreach (@interface) {
        $mask[$cmp] = `$IFCONFIG $interface[$cmp] | $GREP Mas`;
        ($brol,$mask[$cmp]) = split("Mas",$mask[$cmp]);
	($brol,$mask[$cmp]) = split(":",$mask[$cmp]);
	chomp($mask[$cmp]);
        $cmp = $cmp+1;
}
my @result;
$cmp = 0;
foreach (@interface) {
        $result[$cmp][0] = $interface[$cmp];
        $result[$cmp][1] = $ip[$cmp];
	$result[$cmp][2] = $mask[$cmp];
        $cmp = $cmp+1;
}
return @result;
}

#--------------------Les infos de nvidia-settings--------------------------------------
sub Nvidia {
	my ($param,$NVIDIA) = @_;
	my @Core = `$NVIDIA -q $param`;
	@Core = split(":",$Core[0]);
	chomp($Core[2]);
	return $Core[2];   
}

#-------------------Renvois l'Etat du TwinView des Drivers Nvidia-----------------------
sub TwinView {
	my $NVIDIA = shift;
	my @Twin = `$NVIDIA -q TwinView`;
	@Twin = split(":",$Twin[0]);
	chomp($Twin[2]);
	if ($Twin[2] eq " 0.") {
		return "Dsactiv";
	} else {
		return "Activ";
	} 
	
}

#------------------Renvois les temperatures obtenue grce a lm_sensors------------------
sub SensorsTemp {
	my ($param,$SENSORS,$GREP) = @_;
	my $Temp = `$SENSORS | $GREP $param`;
	$Temp =~ s/ * /;/gi;
	(my $titre,$Temp,my @brol) = split(";",$Temp);
	if ($Temp eq "Temp:") {
		($Temp,my @brol) = split(";",$brol[0]);
	}
	return $Temp;
}

#------------------Version de KDE,Qt,kde-config-----------------------------------------
sub KdeVer {
	my ($param,$KDE,$GREP,$SED) = @_;
	my $version = `$KDE -v | $GREP $param | $SED -e 's/.*: //'`;
	return $version;
}

#----------------Renvois le type de Distribution----------------------------------------
sub Distro {
	my $CAT = shift;
	my $image = "none";
	my $distro = "Distribution Inconnue";
	if (-e "/etc/lsb-release") {
		$distro = ubuntinfo($CAT);
		$image = "ubuntu.png"
	} else {
		if (-e "/etc/blackPanther-release") {
			$distro = `$CAT /etc/blackPanther-release`;
			$image = "blackPanther.png";
	} else {
		if (-e "/etc/slackware-version") {
			$distro = `$CAT /etc/slackware-version`;
			$image = "slackware.png";
		} else {
	 		if (-e "/etc/debian_version") {
	   			$distro = `$CAT /etc/debian_version`;
	   			$distro = "Debian ".$distro;
	   			$image = "debian.png";
	 		} else {
	  			 if (-e "/etc/libranet_version") {
	    				$distro = `$CAT /etc/libranet_version`;
	   			} else {
	      				if (-e "/etc/mandrake-release") {
	      					$distro = `$CAT /etc/mandrake-release`;
	       					$image = "mandrake.png";
	  				 } else {
	    					if (-e "/etc/redhat-release") {
	     						$distro = `$CAT /etc/redhat-release`;
	     						$image = "redhat.png";
	    					} else {
	     						if (-e "/etc/SuSE-release") {
	      							$distro = `$CAT /etc/SuSE-release`;
	     						} else {
	       							if (-e "/etc/gentoo-release") {
	        							$distro = `$CAT /etc/gentoo-release`;
									$image = "gentoo.png";
	       							} else {
	        							if (-e "/etc/turbolinux-release") {
		  								$distro = `$CAT /etc/turbolinux-release`;
									} 
	      							}
	    						}
	     					}
	    				}
	   			}
	  		}
	 	}
	    }
	}
	return ($distro,$image);
}


#Fonction crite par Saintshakajin
sub ubuntinfo {
	my $CAT = shift;
	my @tab = split (" ",`$CAT /etc/lsb-release`);
	my ($trash,$id) = split ("=",$tab[0]);
	($trash,my $codename) = split ("=",$tab[1]);
	($trash,my $release) = split ("=",$tab[2]);
	return $id." ".$codename." ".$release;
}

#------------------Renvois le Nom et le Version du Systeme X-------------------------------------
sub XServer {
	my ($X,$GREP,$AWK) = @_;
	my $XServerV; 
	my $XServer = `$X | $GREP X.Org"."version | $AWK '{print \$1}'`;
	if ($XServer ne "") { 
		 $XServerV = `$X | $GREP X.Org"."version | $AWK '{print \$3}'`;
	} else {
		$XServer = `$X | $GREP XFree86"."version | $AWK '{print \$1}'`;
		if ($XServer ne "") {
			$XServerV = `$X | $GREP XFree86"."version | $AWK '{print \$3}'`;
		} else {
			$XServer = "Inconnu";
			$XServerV = "Inconnu";
			
		}
	}
	return ($XServer,$XServerV);
}

#----------------------Renvois la Rsolution de l'ecran dans X-----------------------------------
sub Xinfo {
	my ($param,$X,$GREP) = @_;
	my $Xinfo = `$X | $GREP $param`;
	(my $brol,$Xinfo) = split(":",$Xinfo);
	($Xinfo,$brol) = split("pixels",$Xinfo);
	return $Xinfo;
}

#------------------------Retourne la Version de GCC-----------------------------------------------
sub Gcc {
	my $GCC = shift;
	if ($GCC eq "Not Found") {
		return ($GCC,"none\n");
	} else {
		my @res;
		$res[0] = `$GCC -dumpversion`;
		$res[1] = `$GCC -dumpmachine`;
		chomp($res[0]);
		return @res;
	}
}


#-----------------------Retourne la version de Perl-----------------------------------------------
sub Perl {
	my ($PERL,$GREP) = @_;
	if ($PERL eq "Not Found") {
		return $PERL;
	} else {
		my $res = `$PERL -v | $GREP built`;
		(my $brol,$res) = split(",",$res);
		return $res;
	}
	
}

#------------------------Dtection de la version de Alsa--------------------
sub AlsaVersion {
	my $ALSA = shift;
	my $alsa = `$ALSA -v`;
	$alsa =~ s/ * /;/gi;
	my $brol;
	($brol,$brol,$alsa) = split(";",$alsa);
	return $alsa;
}

#--------------------Dtection de la Version de Fluxbox-------------------
#Fonction code par Saintshakajin
sub fluxinfo {
        my ($param,$FLUXBOX,$GREP) = @_;
        my $fluxinfo = `$FLUXBOX -v | $GREP $param 2>&1`;
        (my $thrash,$fluxinfo) = split(":",$fluxinfo);
        ($thrash,$fluxinfo) = split(" ",$thrash);
	chomp($fluxinfo);
        return $fluxinfo;
}


#-----------------------Dtection de la Version de Gnome------------------------------------------
sub GnomeVersion {
	my ($HEAD,$GREP) = @_;
	my $platform = `$HEAD /usr/share/gnome-about/gnome-version.xml | $GREP '<platform>'`;
	$platform = TraiteGVItem($platform);
	my $minor = `$HEAD /usr/share/gnome-about/gnome-version.xml | $GREP '<minor>'`;
	$minor = TraiteGVItem($minor);
	my $micro = `$HEAD /usr/share/gnome-about/gnome-version.xml | $GREP '<micro>'`;
	$micro = TraiteGVItem($micro);
	return ($platform,$minor,$micro);
	
}

sub TraiteGVItem {
	my $item = shift;
	$item =~ s/<\/.*>//gi;
	$item =~ s/<.*>//gi;
	$item =~ s/ * //gi;
	chomp($item);
	return $item;
}
#-------------------Table de routage-----------------------------------
sub route {
	my $ROUTE = shift;
	my @route = `$ROUTE -n`;
	my $cmp = 0;
	my $cmpr = 0;
	my @result;
	foreach (@route) {
		if ($cmp > 1) {
			$route[$cmp] =~ s/ * /;/gi;
			($result[$cmpr][0],$result[$cmpr][1],$result[$cmpr][2],$result[$cmpr][3],$result[$cmpr][4],$result[$cmpr][5],$result[$cmpr][6],$result[$cmpr][7]) = split(";", $route[$cmp]);
			chomp($result[$cmpr][7]);
			$cmpr += 1;
		}
		$cmp += 1;
	}
	return @result;
}

#--------------------Dtection de la version de IceWm--------------------------
sub IceWmVersion {
	my $ICEWM = shift;
	my $icewmV = `$ICEWM --version`;
	($icewmV,my $brol) = split(",",$icewmV);
	$icewmV =~ s/ * /;/gi;
	($brol,$icewmV,$brol) = split(";",$icewmV);
	return $icewmV;
}

#---------------------Rcuperation des infos de l'ACPI--------------------
sub acpinfo {
	my ($link,$name,$CAT,$GREP) = @_;
	my $info = `$CAT $link | $GREP $name`;
	$info =~ s/ * //gi;
	(my $brol,$info) = split(":",$info);
	return $info;
}

#-------------------Version de Glib--------------------------------------
sub glib {
	my $GLIB = shift;
	my $version = `$GLIB --version`;
	return $version;
}

#----------------Hostname------------------------------------------------
sub hostname {
	my $HOST = shift;
	my $hostname = `$HOST`;
	chomp($hostname);
	return $hostname;
}

1;

